
Data ADSl ;
	Length STUDYID $200	DOMAIN $200	USUBJID $200	SUBJID $200	SITEID $200	BRTHDTC $200	AGE 8	AGEU $200	AGEGR1 $200	
SEX $200	RACE $200	ETHNIC $200	ARMCD $200	ARM $200	ACTARMCD $20	ACTARM $200	SAFFL $2	SAFXL $200	PKFL $2	
PKXL $200	ENRLFL $2	POP01FL $2	PARTAFL $2	PARTBFL $2	POP02FL $2	GROUP01 $40	COMPLFL $2	COMPLFLD $40	COMPTRFL $2	
COMPTRFD $40	RFSTDTC $19	RFENDTC $19	RFXSTDTC  $19	RFXENDTC  $19	RFPENDTC  $19	COUNTRY $200	DTHFL $200	
DTHDTC $200	DTHDY 8	BLBMI 8	BLHGHT 8	BLWGHT 8	BLECOG $200	BLECOGN 8	TRT01A $200	TRT02A $200	TRT03A $200	
TRT01P $200	TRT02P $200	TRT03P $200	TR01SDTM 8	TR01EDTM 8	TR02SDTM 8	TR02EDTM 8	TR03SDTM 8	TR03EDTM 8	TRTSDTM 8	
TRTEDTM 8	TRTSDT 8	TRTEDT 8	TR01SDT 8	TR01EDT 8	TR02SDT 8	TR02EDT 8	TR03SDT 8	TR03EDT 8 ;
	Set ADAM.ADSL (rename=(SUBJID = SUBJID1 SITEID = SITEID1 TR02SDTM=TR02SDTM1 TR02EDTM = TR02EDTM1 TR03SDTM=TR03SDTM1
						   TR03EDTM = TR03EDTM1));

	SUBJID = put(SUBJID1,8.) ;
	SITEID = put(SITEID1,8.) ;
	TR02SDTM = input(TR02SDTM1,yymmdd10.) ;
	TR02EDTM = input(TR02EDTM1,yymmdd10.) ;
	TR03SDTM = input(TR03SDTM1,yymmdd10.) ;
	TR03EDTM = input(TR03EDTM1,yymmdd10.) ;
Run ;

data ADEX1;
	merge adsl(in=a drop=studyid domain) sdtm.ex(in=b);
	by usubjid;
	length adtm adt atm ady exendtci adurn aperiod 8 aduru $10 aperiodc $40;
	if a and b;

/* time variables for using in derivations*/
	if length(EXSTDTC)>=10 then ADT = input(substr(EXSTDTC,1,10),yymmdd10.);
	format ADT yymmdd10.;
	if length(EXSTDTC)>=16 then do;
		ATM = input(substr(EXSTDTC,12,5),time5.);
		ADTM = dhms(ADT,0,0,ATM);
	end;
	format ATM time5.;
	format ADTM datetime19.;

	if length(EXENDTC)>=10 then AEDT = input(substr(EXENDTC,1,10),yymmdd10.);
	format AEDT yymmdd10.;
	if length(EXENDTC)>=16 then AETM = input(substr(EXENDTC,12,5),time5.);
	format AETM time5.;

/*ADY*/
	if nmiss(ADT,TRTSDT)=0 then do;	
		ADY = ADT - TRTSDT + 1*(ADT>=TRTSDT);
	end;

%MACRO prd_aperiod(onset=ADT,conttrt=TR03SDT);
 length aperiodc $40;
  if partafl="Y" and partbfl="Y" and pop02fl="Y" then do;
    if &onset.<TR02SDT then APERIOD=1;
    else if &onset.<&conttrt. then APERIOD=2;
    else if &onset.>=&conttrt. then APERIOD=3;
  end;
  else if partafl="Y" and partbfl="Y" and pop02fl="N" then do;
    if &onset.<TR02SDT then APERIOD=1;
    else if .<&onset.<=(trtedt+37) then APERIOD=2;
  end;
  else if partafl="Y" and partbfl="N" and pop02fl="Y" then do;
    if &onset.<&conttrt. then APERIOD=1;
  else APERIOD=3;
  end;
  else if partafl="Y" and partbfl="N" and pop02fl="N" then do;
     if .<&onset.<=(trtedt+37) then APERIOD=1;
  end;

  if APERIOD=1 then APERIODC="Part A";
  else if APERIOD=2 then APERIODC="Part B";
  else if APERIOD=3 then APERIODC="Continued Access";
 	
%MEND;

%prd_aperiod ;

/*EXENDTCI*/
	if APERIOD = 1 then EXENDTCI = TR01EDT;else EXENDTCI = AEDT;
	format EXENDTCI yymmdd10.;

/*ADURN ADURU*/
	if nmiss(EXENDTCI,ADT)=0 then do;
		ADURN = EXENDTCI - ADT + 1;
		ADURU = "Days";
	End ;

	if ^missing(EXDOSTOT) then DOSE=EXDOSTOT;else if ^missing(EXDOSE) then DOSE=EXDOSE ;
run;

proc sort;by usubjid aperiod exstdtc;run;

data adex2;
	set adex1;
	by usubjid aperiod exstdtc;
	retain EXAMT 0;
	retain EXNUM 0;
	if first.aperiod then do;
		if nmiss(DOSE,ADURN) = 0 then EXAMT = DOSE*ADURN; else EXAMT = 0 ; 
		EXNUM = ADURN;
	end;
	else do;	
		if EXTRT="Dummy" then EXAMT = EXAMT + DOSE*ADURN;
		if EXTRT="Dummy" then EXNUM = EXNUM + ADURN;
	end;
	If last.aperiod ;
run;
proc sort;by usubjid exseq;run;

data adex2_1 (rename= (exseq_ = exseq)) ;
	Set adex1 ;
	EXACN_ = lag(EXACN) ;
	AEDT_ = lag(AEDT) ;
	exseq_ = lag(exseq) ;
	if EXACN_ ="DRUG INTERRUPTED" then do;
		EXINTDUR = ADT - AEDT_;
	end;
	if EXACN_ ="DRUG INTERRUPTED" ;  
	Keep usubjid exseq_ EXINTDUR ;  
Run ;

data adex2_2 ;
	Set adex1 ;
	EXACN_ = lag(EXACN) ;
	AEDT_ = lag(AEDT) ;
	exseq_ = lag(exseq) ;
	if EXACN_ ="DOSE REDUCED" then do;
		EXREDDUR = ADT - AEDT_;
	end;
	if EXACN_ ="DOSE REDUCED" ;  
	Keep usubjid exseq EXREDDUR ;  
Run ; 

data ADEX3;
	merge adex1 ADEX2 (keep=usubjid EXAMT EXNUM aperiod)  ;
	by usubjid aperiod;  
run;

data adex4;
	merge adex3 adex2_1 adex2_2;
	by usubjid exseq;

	if EXACN="DRUG INTERRUPTED" then EXMODADT = AEDT;
	If EXINTDUR = 1 then EXINTDUR = 0 ; 

		/*EXMODADT EXSISDT EXSISDY*/
	if EXACN="DRUG INTERRUPTED" and EXINTDUR > 0  then do;
		EXISDT = AEDT+1;
		format exmodadt EXISDT yymmdd10.;
		EXISDY = EXISDT - TRTSDT + 1;
	end;

	If EXAMT = 0 then EXAMT = . ;

run;

Data adex5 ;
Length STUDYID $200	DOMAIN $200	USUBJID $200	SUBJID $200	SITEID $200	BRTHDTC $200	AGE 8	AGEU $200	AGEGR1 $200	
SEX $200	RACE $200	ETHNIC $200	ARMCD $200	ARM $200	ACTARMCD $20	ACTARM $200	SAFFL $2	SAFXL $200	PKFL $2	
PKXL $200	ENRLFL $2	POP01FL $2	PARTAFL $2	PARTBFL $2	POP02FL $2	GROUP01 $40	COMPLFL $2	COMPLFLD $40	COMPTRFL $2	
COMPTRFD $40	RFSTDTC $19	RFENDTC $19	RFXSTDTC  $19	RFXENDTC  $19	RFPENDTC  $19	COUNTRY $200	DTHFL $200	
DTHDTC $200	DTHDY 8	BLBMI 8	BLHGHT 8	BLWGHT 8	BLECOG $200	BLECOGN 8	TRT01A $200	TRT02A $200	TRT03A $200	
TRT01P $200	TRT02P $200	TRT03P $200	TR01SDTM 8	TR01EDTM 8	TR02SDTM 8	TR02EDTM 8	TR03SDTM 8	TR03EDTM 8	TRTSDTM 8	
TRTEDTM 8	TRTSDT 8	TRTEDT 8	TR01SDT 8	TR01EDT 8	TR02SDT 8	TR02EDT 8	TR03SDT 8	TR03EDT 8 EXSEQ  8	
EXTRT  $200	EXCAT  $200	EXSCAT $200	EXDOSE  8	EXDOSU  $200	EXDOSFRM  $200	EXDOSFRQ  $200	EXDOSTOT  8	
EXROUTE  $200	EXLOT $200	EXADJ  $200	EPOCH  $200	EXSTDTC  $200	EXENDTC  $200	EXSTDY  8	EXENDY  8	ADTM 8	ADT 8	
ATM 8	ADY 8	EXENDTCI 8	EXAMT 8	EXNUM 8	EXMODADT 8	EXINTDUR 8	EXISDT 8	EXISDY 8	EXREDDUR 8	ADURN 8
ADURU $10	APERIOD 8	APERIODC $40;
	Set adex4 ;

Label STUDYID = "Study Identifier"
DOMAIN = "Domain Abbreviation"
USUBJID = "Unique Subject Identifier"
SUBJID = "Subject Identifier for the Study"
SITEID = "Study Site Identifier"
BRTHDTC = "Date/Time of Birth"
AGE = "Age"
AGEU = "Age Units"
AGEGR1 = "Pooled Age Group 1"
SEX = "Sex"
RACE = "Race"
ETHNIC = "Ethnicity"
ARMCD = "Planned Arm Code"
ARM = "Description of Planned Arm"
ACTARMCD = "Actual Arm Code"
ACTARM = "Description of Actual Arm"
SAFFL = "Safety Population Flag"
SAFXL = "Reason for Excl. from Safety Pop"
PKFL = "Pharmacokinetics Population Flag"
PKXL = "Reason for Excl from PK Pop"
ENRLFL = "Enrolled Population Flag"
POP01FL = "Screened Population Flag"
PARTAFL = "Participation in Period 01"
PARTBFL = "Participation in Period 02"
POP02FL = "Ongoing into Continued Access"
GROUP01 = "Grouping Variable 01 Description"
COMPLFL = "Completers Population Flag"
COMPLFLD = "Completers Population Flag Description"
COMPTRFL = "Subject Completed Treatment"
COMPTRFD = "Subject Completed Treatment Description"
RFSTDTC = "Subject Reference Start Date/Time"
RFENDTC = "Subject Reference End Date/Time"
RFXSTDTC  = "Date/Time of First Study Treatment "
RFXENDTC  = "Date/Time of Last Study Treatment "
RFPENDTC  = "Date/Time of End of Participation "
COUNTRY = "Country"
DTHFL = "Subject Death Flag"
DTHDTC = "Date/Time of Death"
DTHDY = "Study Day of Death"
BLBMI = "Baseline Body Mass Index (kg/m**2)"
BLHGHT = "Baseline Height (cm)"
BLWGHT = "Baseline Weight (kg)"
BLECOG = "Baseline WHO performance status"
BLECOGN = "Baseline WHO performance status (N)"
TRT01A = "Actual Treatment for Period 01"
TRT02A = "Actual Treatment for Period 02"
TRT03A = "Actual Treatment for Period 03"
TRT01P = "Planned Treatment for Period 01"
TRT02P = "Planned Treatment for Period 02"
TRT03P = "Planned Treatment for Period 03"
TR01SDTM = "DateTime of First Exposure in Period 01"
TR01EDTM = "DateTime of Last Exposure in Period 01"
TR02SDTM = "DateTime of First Exposure in Period 02"
TR02EDTM = "DateTime of Last Exposure in Period 02"
TR03SDTM = "DateTime of First Exposure in Period 03"
TR03EDTM = "DateTime of Last Exposure in Period 03"
TRTSDTM = "DateTime of First Exposure to treatment"
TRTEDTM = "DateTime of Last Exposure to treatment"
TRTSDT = "Date of First Exposure to treatment"
TRTEDT = "Date of Last Exposure to treatment"
TR01SDT = "Date of First Exposure in Period 01"
TR01EDT = "Date of Last Exposure in Period 01"
TR02SDT = "Date of First Exposure in Period 02"
TR02EDT = "Date of Last Exposure in Period 02"
TR03SDT = "Date of First Exposure in Period 03"
TR03EDT = "Date of Last Exposure in Period 03"
EXSEQ  = "Sequence Number"
EXTRT  = "Name of Actual Treatment"
EXCAT  = "Category for Treatment"
EXSCAT = "Subcategory for Treatment"
EXDOSE  = "Dose per Administration"
EXDOSU  = "Dose Units"
EXDOSFRM  = "Dose Form"
EXDOSFRQ  = "Dosing Frequency per Interval"
EXDOSTOT  = "Total Daily Dose"
EXROUTE  = "Route of Administration"
EXLOT = "Lot Number"
EXADJ  = "Reason for Dose Adjustment"
EPOCH  = "Epoch "
EXSTDTC  = "Start Date/Time of Treatment"
EXENDTC  = "End Date/Time of Treatment"
EXSTDY  = "Study Day of Start of Treatment"
EXENDY  = "Study Day of End of Treatment"
ADTM = "Analysis Date/Time"
ADT = "Analysis Date"
ATM = "Analysis Time"
ADY = "Analysis Relative Day"
EXENDTCI = "End Date of Treatment (imputed)"
EXAMT = "Amount of Dose"
EXNUM = "Number of Doses received"
EXMODADT = "Modification Start Date"
EXINTDUR = "Duration of Interruptions"
EXISDT = "Analysis Start Date of Interruption"
EXISDY = "Relative Start Day of Interruption"
EXREDDUR = "Duration of Reductions"
ADURN = "Duration (N)"
ADURU = "Duration Units"
APERIOD = "Period"
APERIODC = "Period (C)";

Keep STUDYID	DOMAIN	USUBJID	SUBJID	SITEID	BRTHDTC	AGE	AGEU	AGEGR1	SEX	RACE	ETHNIC	ARMCD	ARM	ACTARMCD	
	ACTARM	SAFFL	SAFXL	PKFL	PKXL	ENRLFL	POP01FL	PARTAFL	PARTBFL	POP02FL	GROUP01	COMPLFL	COMPLFLD	COMPTRFL	
	COMPTRFD	RFSTDTC	RFENDTC	RFXSTDTC 	RFXENDTC 	RFPENDTC 	COUNTRY	DTHFL	DTHDTC	DTHDY	BLBMI	BLHGHT	BLWGHT	
	BLECOG	BLECOGN	TRT01A	TRT02A	TRT03A	TRT01P	TRT02P	TRT03P	TR01SDTM	TR01EDTM	TR02SDTM	TR02EDTM	TR03SDTM
	TR03EDTM	TRTSDTM	TRTEDTM	TRTSDT	TRTEDT	TR01SDT	TR01EDT	TR02SDT	TR02EDT	TR03SDT	TR03EDT	EXSEQ 	EXTRT 	EXCAT 	
	EXSCAT	EXDOSE 	EXDOSU 	EXDOSFRM 	EXDOSFRQ 	EXDOSTOT 	EXROUTE 	EXLOT	EXADJ 	EPOCH 	EXSTDTC 	EXENDTC 	
	EXSTDY 	EXENDY 	ADTM	ADT	ATM	ADY	EXENDTCI	EXAMT	EXNUM	EXMODADT	EXINTDUR	EXISDT	EXISDY	EXREDDUR	
	ADURN	ADURU	APERIOD	APERIODC ;

Run ;

Data ADAM.EX ;
	Set ADEX5 ;
	Proc sort ; By STUDYID USUBJID EXTRT EXSTDTC ;
Run ;




