

Data AE1 (rename=(AEACN1=AEACN));
	length AEACN1 AEOUT1  AEACN $200 USUBJID $30;
	Set CDM.AE (where=(AENO ne . ));

	STUDYID = "XYZ" ;
	DOMAIN  = "AE" ;
	USUBJID = Strip(STUDYID) || "/" || Strip(Put(SUBJECT,best.)) ;

	AESPID = trim(left(put(AENO ,best.))); 

	AELLT 		= LLT_NAME	;
	AELLTCD 	= LLT_CODE 	;
	AEDECOD 	= PT_NAME 	; 
	AEPTCD 		= PT_CODE 	;
	AEHLT 		= HLT_NAME 	; 
	AEHLTCD 	= HLT_CODE 	;
	AEHLGT 		= HLGTNAME 	; 
	AEHLGTCD 	= HLGTCODE 	;
	AEBODSYS 	= SOC_NAME	;
	AEBDSYCD 	= SOC_CODE	;
	AESOC 		= SOC_NAME	; 
	AESOCCD 	= SOC_CODE	;
	CTC			= CTCAE_V	;
	IP			= IP		;
	MEDDRAV		= MEDDRA_V	;

	If AECATOCC = "1" then do ;
		if not missing (AECAT1) then AECAT = Upcase(AECAT1) ;
		if not missing (AECAT2) then AECAT = Upcase(AECAT2) ;
		if not missing (AECAT3) then AECAT = Upcase(AECAT3) ;
	End ; 

	If 		AESER = "1" Then AESER = "Y" ;
	Else if AESER = "0" Then AESER = "N" ;

	if Strip(compress(AEACN))  = "0"  then AEACN1 = "Dose Not Changed" ;
	if Strip(compress(AEACN))  = "3"  then AEACN1 = "Drug Interrupted" ;
	if Strip(compress(AEACN))  = "4"  then AEACN1 = "Drug Withdrawn" ;
	if Strip(compress(AEACN))  = "98" then AEACN1 = "Not Applicable" ;
	*Else AEACN1 = " " ;

	AEACN1 = Upcase (AEACN1) ;

	if Strip(AEOUT)  = "0"  then AEOUT1 = "Recovered/Resolved" ;
	if Strip(AEOUT)  = "1"  then AEOUT1 = "Recovering/Resolving" ;
	if Strip(AEOUT)  = "3"  then AEOUT1 = "Not Recovered/Not Resolved" 	;
	Else AEOUT = " " ;

	If 		 AEREL = "1" then AEREL = "Y" ;
	Else if  AEREL = "0" then AEREL = "N" ;

	
	Format AEOUT1  $200. ;
	Drop AEOUT AEACN; 
Run ;

Data AE2 ;
	Set AE1 ;
	AEOUT = Upcase(AEOUT1) ; 
run ;

Data AE3 ;
	Merge CDM.SERAE (rename=(AETERM = AETERM1)) AE2 (in=a) ;
	By SUBJECT AENO ;
	If a ;
Run ;

Data AE4 ;
	Length AEDESC01 - AEDESC05 $300 AEDESC06 - AEDESC10 $200 ;
	Set AE3 ;

	If AETERM1 ne " " then AETERM = AETERM1 ;
	AETERM = Upcase(AETERM) ; 

	If AESMEDCA = '1' then do ;
		AERELNST = "CAUSED BY OTHER MEDICATION " || Upcase(AESMED) ;
	End ;
	
	If 		 AESCONG = "1" then AESCONG = "Y" ;
	Else if  AESCONG = "0" then AESCONG = "N" ;

	If 		 AESDISAB = "1" then AESDISAB = "Y" ;
	Else if  AESDISAB = "0" then AESDISAB = "N" ;

	If 		 AESDTH = "1" then AESDTH = "Y" ;
	Else if  AESDTH = "0" then AESDTH = "N" ;

	If 		 AESHOSP = "1" then AESHOSP = "Y" ;
	Else if  AESHOSP = "0" then AESHOSP = "N" ;

	If 		 AESLIFE = "1" then AESLIFE = "Y" ;
	Else if  AESLIFE = "0" then AESLIFE = "N" ;

	If 		 AESMIE = "1" then AESMIE = "Y" ;
	Else if  AESMIE = "0" then AESMIE = "N" ;

	If 		 AETRT = "1" then AECONTRT = "Y" ;
	Else if  AETRT = "0" then AECONTRT = "N" ;

	If 		 AEDIS = "1" then AEWD = "Y" ;
	Else if  AEDIS = "0" then AEWD = "N" ;

	If 		 AECAUSSP = "1" then SAECAUSP = "Y" ;

	
	Array AEC {9} AEC01TOX AEC02TOX AEC03TOX AEC04TOX AEC05TOX AEC06TOX AEC07TOX AEC08TOX AEC09TOX;
	Array  AEC1 {9}  AEC01TOX1 AEC02TOX2 AEC03TOX3 AEC04TOX4 AEC05TOX5 AEC06TOX6 AEC07TOX7 AEC08TOX8 AEC09TOX9;
 		Do i=1 to 9;
 		AEC1[i]=input(AEC[i],??best.);
 	End;

	if nmiss (AEC01TOX1,AEC02TOX2,AEC03TOX3,AEC04TOX4,AEC05TOX5,AEC06TOX6,AEC07TOX7,AEC08TOX8,AEC09TOX9) = 0 then
			AETOXGR_1 = max(AEC01TOX1,AEC02TOX2,AEC03TOX3,AEC04TOX4,AEC05TOX5,AEC06TOX6,AEC07TOX7,AEC08TOX8,AEC09TOX9) ;

	if not missing (AETOXGRM) then AETOXGR = AETOXGRM ;
	else AETOXGR = put(AETOXGR_1,best.) ;

	AESTDTC = AESTDAT || AESTTIM ;
	AEENDTC = AEENDAT || AEENTIM ;

	If  missing (AEENDTC) and AEOUT ^= "RECOVERED/RESOLVED" then AEENRTPT = "ONGOING" ;
	If  missing (AEENDTC) and AEOUT ^= "RECOVERED/RESOLVED" then AEENTPT  = "STUDY TERMINATION" ;

	Array AEDESC {10} AEDESC01 AEDESC02 AEDESC03 AEDESC04 AEDESC05 AEDESC06 AEDESC07 AEDESC08 AEDESC09 AEDESC10;
 		Do i=1 to 10;
 		AEDESC[i]=Upcase(AEDESC [i]);
 	End;

	SAEDIDTC =  AESDIDAT;
	SAEDTC	 =  AESDAT ;
	SAEHODTC =  AESHODAT ;
	SAEIADTC =  AESIADAT;

	SAESP 	= AESP 	   ;
	SOCABRV = SOC_ABRV ;


	*Format SAEDIDTC SAEDTC SAEHODTC SAEIADTC  yymmdd10. ; 
	
Run ;

Data AE5 ;
	Merge AE4 (in=a) SDTM.DM(drop=STUDYID DOMAIN) ;
	BY USUBJID ;
	If a ;
Run ;

Data AE6 ;
	Set AE5 ;
	If cmiss(AESTDTC,RFSTDTC) = 0 and input(AESTDTC,yymmdd10.) >= input(RFSTDTC,yymmdd10.) then do ;
		AESTDY = (input(AESTDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) + 1 ;
	End ;
	If cmiss(AESTDTC,RFSTDTC) = 0 and input(AESTDTC,yymmdd10.) < input(RFSTDTC,yymmdd10.) then do ;
		AESTDY = (input(AESTDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) ;
	End ; 

	If cmiss(AEENDTC,RFSTDTC) = 0 and input(AEENDTC,yymmdd10.) >= input(RFSTDTC,yymmdd10.) then do ;
		AEENDY = (input(AEENDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) + 1 ;
	End ;
	If cmiss(AEENDTC,RFSTDTC) = 0 and input(AEENDTC,yymmdd10.) < input(RFSTDTC,yymmdd10.) then do ;
		AEENDY = (input(AEENDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) ;
	End ;

	If RFSTDTC < AESTDTC < RFENDTC then AETRTEM = "Y" ;
	Else AETRTEM = "N" ; 

	Proc sort ; By STUDYID USUBJID AEDECOD AESTDTC AESPID ;
run ;

Data AE7 ;
	Set AE6 ;
	By STUDYID USUBJID AEDECOD AESTDTC AESPID ;

	If First.USUBJID then AESEQ = 1 ; 
	else AESEQ + 1 ;	
Run ; 

Data AE8 ;
	Length STUDYID $21	DOMAIN $8	USUBJID $30	AESEQ 8	AESPID $40	AETERM $200	AELLT $200	AELLTCD 8	AEDECOD $200	
		   AEPTCD 8	AEHLT $200	AEHLTCD 8	AEHLGT $200	AEHLGTCD 8	AECAT $200	AEBODSYS $200	AEBDSYCD 8	AESOC $200	
		   AESOCCD 8	AESER $1	AEACN $200	AEREL $200	AERELNST $200	AEOUT $200	AESCONG $1	AESDISAB $1	AESDTH $1	
		   AESHOSP $1	AESLIFE $1	AESMIE $1	AECONTRT $1	AETOXGR $1	AESTDTC $19	AEENDTC $19	AESTDY 8	AEENDY 8	
		   AEENRTPT $40	AEENTPT $40	AEDESC01 $300	AEDESC02 $300	AEDESC03 $300	AEDESC04 $300	AEDESC05 $300	
		   AEDESC06 $200	AEDESC07 $200	AEDESC08 $200	AEDESC09 $200	AEDESC10 $200	AEWD $1	CTC$20	IP $200	
		   MEDDRAV $20	SAECAUSP $1	SAEDIDTC$19	SAEDTC $19	SAEHODTC $19	SAEIADTC $19	SAESP $200	SOCABRV $200	
		   AETRTEM $1 ;

	Set AE7 ;

Label STUDYID = "Study Identifier"
DOMAIN = "Domain Abbreviation"
USUBJID = "Unique Subject Identifier"
AESEQ = "Sequence Number"
AESPID = "Sponsor-Defined Identifier"
AETERM = "Reported Term for the Adverse Event"
AELLT = "Lowest Level Term"
AELLTCD = "Lowest Level Term Code"
AEDECOD = "Dictionary-Derived Term"
AEPTCD = "Preferred Term Code"
AEHLT = "High Level Term"
AEHLTCD = "High Level Term Code"
AEHLGT = "High Level Group Term"
AEHLGTCD = "High Level Group Term Code"
AECAT = "Category for Adverse Event"
AEBODSYS = "Body System or Organ Class"
AEBDSYCD = "Body System or Organ Class Code"
AESOC = "Primary System Organ Class"
AESOCCD = "Primary System Organ Class Code"
AESER = "Serious Event"
AEACN= "Action Taken with Study Treatment"
AEREL = "Causality"
AERELNST = "Relationship to Non-Study Treatment"
AEOUT = "Outcome of Adverse Event"
AESCONG = "Congenital Anomaly or Birth Defect"
AESDISAB = "Persist or Signif Disability/Incapacity"
AESDTH = "Results in Death"
AESHOSP = "Requires or Prolongs Hospitalization"
AESLIFE = "Is Life Threatening"
AESMIE = "Other Medically Important Serious Event"
AECONTRT = "Concomitant or Additional Trtmnt Given"
AETOXGR = "Standard Toxicity Grade"
AESTDTC = "Start Date/Time of Adverse Event"
AEENDTC = "End Date/Time of Adverse Event"
AESTDY = "Study Day of Start of Adverse Event"
AEENDY = "Study Day of End of Adverse Event"
AEENRTPT = "End Relative to Reference Time Point"
AEENTPT = "End Reference Time Point"
AEDESC01 = "AE Description 01"
AEDESC02 = "AE Description 02"
AEDESC03 = "AE Description 03"
AEDESC04 = "AE Description 04"
AEDESC05 = "AE Description 05"
AEDESC06 = "AE Description 06"
AEDESC07 = "AE Description 07"
AEDESC08 = "AE Description 08"
AEDESC09 = "AE Description 09"
AEDESC10 = "AE Description 10"
AEWD = "AE Caused Subject to Withdraw from Study"
CTC= "CTC Version"
IP = "Investigational Product"
MEDDRAV= "MedDRA Version"
SAECAUSP = "SAE Caused by Study Procedure(s)"
SAEDIDTC= "Date of Discharge"
SAEDTC= "Date/Time AE Met Criteria for Serious AE"
SAEHODTC= "Date of Hospitalization"
SAEIADTC= "Date Investigator Aware of Serious AE"
SAESP= "Study Procedure(s)"
SOCABRV= "MedDRA System Organ Class Abbreviation"
AETRTEM= "Treatment Emergent Flag" ;

Keep STUDYID 	DOMAIN 	USUBJID 	AESEQ 	AESPID 	AETERM 	AELLT 	AELLTCD 	AEDECOD 	AEPTCD 	AEHLT 	AEHLTCD 	
	 AEHLGT 	AEHLGTCD 	AECAT 	AEBODSYS 	AEBDSYCD 	AESOC 	AESOCCD 	AESER 	AEACN	AEREL 	AERELNST 	AEOUT 	
	 AESCONG 	AESDISAB 	AESDTH 	AESHOSP 	AESLIFE 	AESMIE 	AECONTRT 	AETOXGR 	AESTDTC 	AEENDTC 	AESTDY 	
	 AEENDY 	AEENRTPT 	AEENTPT 	AEDESC01 	AEDESC02 	AEDESC03 	AEDESC04 	AEDESC05 	AEDESC06 	AEDESC07 
	 AEDESC08 	AEDESC09 	AEDESC10 	AEWD 	CTC	IP 	MEDDRAV	SAECAUSP 	SAEDIDTC	SAEDTC	SAEHODTC	SAEIADTC	
	SAESP	SOCABRV	AETRTEM ;


Run ;

Data SDTM.AE ;
	Set AE8 ;
	Proc sort ; By STUDYID USUBJID AEDECOD AESTDTC AESPID ;
Run ;
