

Data EX1 ;
	Set CDM.EX ;
Run ;

/*note that since OVERDOSE have no data its ignored*/

data SPCPKB1 ;
	set CDM.SPCPKB1 ;
	Where IPFD1DAT ne " " ;
proc sort ; by  SUBJECT IPFD1DAT  ; 
run ;

Data DA ;
	Set CDM.DA ;
	Where DASCAT="Dummy" ;
	IPFD1DAT = DACDAT ;
	Proc sort ; By SUBJECT IPFD1DAT ;  
Run ;

Data SPCPKB2 ;
	Merge SPCPKB1 DA ;
	By SUBJECT IPFD1DAT ;
	EXSTDAT = IPFD1DAT ; 
Run ; 

Proc sort data = EX1 ; By SUBJECT EXSTDAT ; Run ;

Data EX2 (rename=(EXADJ1 = EXADJ EXACN1=EXACN));
	Length EXCAT EXACN1 $40 EXADJ1  EXTRT $200  USUBJID $30 ;;
	Merge SPCPKB2 (In=a)   EX1 (in=b) ;
	By SUBJECT EXSTDAT  ;

	STUDYID = "XYZ" ;
	DOMAIN  = "EX" ;
	USUBJID = Strip(STUDYID) || "/" || Strip(Put(SUBJECT,best.)) ;

	EXCAT = "INVESTIGATIONAL PRODUCT" ;
	EXTRT = "Dummy" ;

	EXDOSE   = EXTDDOSE ;
	EXDOSU 	 = "mg" 	;
	EXDOSFRM = "TABLET" ;
	EXDOSFRQ = "ONCE" 	;
	EXDOSTOT = EXTDDOSE ;
	EXROUTE  = "ORAL"	;
	EXLOT 	 = DAPCIDEX ;
	AESPID1  = put(EXAENO1,3.) 	;
	AESPID2  = put(EXAENO2,3.) 	;
	EXADMREA = EXNAPROT ;
	EXSTR 	 = Put(EXDOSTOT,8.) ;
	EXADJDSC = EXADJS ;

	EXSTRU = "mg" ;

	If Strip(EXAPROT) = "0" then EXADMSTA = "NOT ACCORDING TO PROTOCOL" ;

	If Strip(EXAPROT) = "1" then EXADMSTA = "ACCORDING TO PROTOCOL" ;

	/*AESPID2 - AESPID9 and AETERM1 - AETERM9 will be missing since OVERDOSE having no data*/
	
	AESPID3  = " "	;
	AESPID4  = " " 	;
	AESPID5  = " "	;
	AESPID6  = " " 	;
	AESPID7  = " "	;
	AESPID8  = " " 	;
	AESPID9  = " "	;


	AETERM1  = " "	;
	AETERM2  = " "	;
	AETERM3  = " "	;
	AETERM4  = " " 	;
	AETERM5  = " "	;
	AETERM6  = " " 	;
	AETERM7  = " "	;
	AETERM8  = " " 	;
	AETERM9  = " "	;

	ODAE 	 = " " ;
	ODAECOM  = " " ;
	ODINTENT = " " ;
	EXSCAT   = " " ;

	VISITDTC = VIS_DAT ;
	EXDTC    = DACDAT  ;
	EXSPFY   = DACOM   ;

	If Strip(EXADJ)  = "1"   then EXADJ1 = "Adverse Event" ;
	If Strip(EXADJ)  = "17"  then EXADJ1 = "Subject Forgot to Take Dose" ;
	If Strip(EXADJ)  = "99"  then EXADJ1 = "Other" ; 

	If Strip(EXACN)  = "0"   then EXACN1 = "Dose Not Changed" ;
	If Strip(EXACN)  = "3"   then EXACN1 = "Drug Interrupted" ;
	If Strip(EXACN)  = "4"   then EXACN1 = "Drug Permanently Discontinued" ;
	If Strip(EXACN)  = "98"  then EXACN1 = "Not Applicable" ;

	If IPFD1DAT ne " " then EXSTDTC = IPFD1DAT || "T" || IPFD1TIM ;
	Else EXSTDTC = EXSTDAT ;

	If IPFD1DAT ne " " then EXENDTC = IPFD1DAT || "T" || IPFD1TIM ;
	Else EXENDTC = EXENDAT ; 


	Format EXADJ1 $200. EXTRT EXCAT $200. ;
	Drop EXADJ EXACN ; 

	Proc sort ; By SUBJECT EXSTDAT ; 
Run ;

Data VISIT ;
	Set CDM.VISIT ;
	If PSCHDAY ne 9998 ;
	EXSTDAT = VIS_DAT ;
	Keep  SUBJECT EXSTDAT VISIT  ;
	Proc sort nodupkey ; By SUBJECT EXSTDAT   ;
Run ;

Data EX3 ;
	Merge EX2(in=a) VISIT ;
	By SUBJECT EXSTDAT   ; 
	If a ;
	VISITNUM = VISIT ;
	Drop VISIT ; 
	Proc sort; By VISITNUM ; 
Run ;

Data TV ;
	Set SDTM.TV ;
Run ;

Data EX4 ;
	merge EX3(in=a) TV ;
	By VISITNUM ;
	If a ;
Run ; 

Data EX5 ;
	Set EX4 ;
	Proc sort ; By USUBJID ; 
Run ;



Data EX6 ;
	Merge EX5(in=a) SDTM.DM(drop=STUDYID DOMAIN VISITDTC ARMCD) ;
	BY USUBJID ;
	If a ;
Run ;

Data EX7 ;
	Set EX6 ;
	If cmiss(EXSTDTC,RFSTDTC) = 0 and input(EXSTDTC,yymmdd10.) >= input(RFSTDTC,yymmdd10.) then do ;
		EXSTDY = (input(EXSTDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) + 1 ;
	End ;
	If cmiss(EXSTDTC,RFSTDTC) = 0 and input(EXSTDTC,yymmdd10.) < input(RFSTDTC,yymmdd10.) then do ;
		EXSTDY = (input(EXSTDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) ;
	End ; 

	If cmiss(EXENDTC,RFSTDTC) = 0 and input(EXENDTC,yymmdd10.) >= input(RFSTDTC,yymmdd10.) then do ;
		EXENDY = (input(EXENDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) + 1 ;
	End ;
	If cmiss(EXENDTC,RFSTDTC) = 0 and input(EXENDTC,yymmdd10.) < input(RFSTDTC,yymmdd10.) then do ;
		EXENDY = (input(EXENDTC,yymmdd10.) - input(RFSTDTC,yymmdd10.)) ;
	End ;


	Proc sort ; By STUDYID USUBJID EXTRT EXSTDTC ;
run ;

Data EX8 ;
	Set EX7 ;
	By STUDYID USUBJID EXTRT EXSTDTC ;

	If First.USUBJID then EXSEQ = 1 ; 
	else EXSEQ + 1 ;	
Run ;

Data EX9 ;
	Length STUDYID  $21	DOMAIN  $8	USUBJID  $30	EXSEQ  8	EXTRT  $200	EXCAT  $40	EXSCAT  $25	EXDOSE  8	EXDOSU  $20	
		   EXDOSFRM  $40	EXDOSFRQ  $40	EXDOSTOT  8	EXROUTE  $20	EXLOT  $40	EXADJ  $200	VISITNUM 8	VISIT $40	
		   VISITDY 8	EXSTDTC  $20	EXENDTC  $19	EXSTDY  8	EXENDY  8	AESPID1 $3	AESPID2 $3	AESPID3 $3	
		   AESPID4 $3	AESPID5 $3	AESPID6 $3	AESPID7 $3	AESPID8 $3	AESPID9 $3	AETERM1 $200	AETERM2 $200	
		   AETERM3 $200	AETERM4 $200	AETERM5 $200	AETERM6 $200	AETERM7 $200	AETERM8 $200	AETERM9 $200	
		   EXACN  $40	EXADJDSC $200	EXADMREA $200	EXADMSTA $30	EXSTR $8	EXSTRU $20	ODAE  $2	ODAECOM  $200	
		   ODINTENT  $2	VISITDTC $19	EXDTC $20	EXSPFY $200 ;

	Set Ex8 ;

	Label STUDYID  = "Study Identifier"
DOMAIN  = "Domain Abbreviation"
USUBJID  = "Unique Subject Identifier"
EXSEQ  = "Sequence Number"
EXTRT  = "Name of Treatment"
EXCAT  = "Category of Treatment"
EXSCAT  = "Subcategory of Treatment"
EXDOSE  = "Dose"
EXDOSU  = "Dose Units"
EXDOSFRM  = "Dose Form"
EXDOSFRQ  = "Dosing Frequency per Interval"
EXDOSTOT  = "Total Daily Dose"
EXROUTE  = "Route of Administration"
EXLOT  = "Lot Number"
EXADJ  = "Reason for Dose Adjustment"
VISITNUM = "Visit Number"
VISIT = "Visit Name"
VISITDY = "Planned Study Day of Visit"
EXSTDTC  = "Start Date/Time of Treatment"
EXENDTC  = "End Date/Time of Treatment"
EXSTDY  = "Study Day of Start of Treatment"
EXENDY  = "Study Day of End of Treatment"
AESPID1 = "AE Number 1"
AESPID2 = "AE Number 2"
AESPID3 = "AE Number 3"
AESPID4 = "AE Number 4"
AESPID5 = "AE Number 5"
AESPID6 = "AE Number 6"
AESPID7 = "AE Number 7"
AESPID8 = "AE Number 8"
AESPID9 = "AE Number 9"
AETERM1 = "AE Term 1"
AETERM2 = "Ae Term 2"
AETERM3 = "AE Term 3"
AETERM4 = "AE Term 4"
AETERM5 = "AE Term 5"
AETERM6 = "AE Term 6"
AETERM7 = "AE Term 7"
AETERM8 = "AE Term 8"
AETERM9 = "AE Term 9"
EXACN  = "Action Taken with Study Drug"
EXADJDSC = "Reason for SD Dose Change Specification"
EXADMREA = "Reason Adm. Not Acc. to Protocol"
EXADMSTA = "Dose Administration Status"
EXSTR = "Strength of Dose"
EXSTRU = "Strength Units"
ODAE  = "Overdose Associated with AE"
ODAECOM  = "Overdose Associated with AE Comment"
ODINTENT  = "Intentional Overdose"
VISITDTC = "Date of Visit"
EXDTC = "Date of Recording"
EXSPFY = "Specification of Exposure" ;

keep STUDYID 	DOMAIN 	USUBJID 	EXSEQ 	EXTRT 	EXCAT 	EXSCAT 	EXDOSE 	EXDOSU 	EXDOSFRM 	EXDOSFRQ 	EXDOSTOT 	
	 EXROUTE 	EXLOT 	EXADJ 	VISITNUM	VISIT	VISITDY	EXSTDTC 	EXENDTC 	EXSTDY 	EXENDY 	AESPID1	AESPID2	AESPID3	
	 AESPID4	AESPID5	AESPID6	AESPID7	AESPID8	AESPID9	AETERM1	AETERM2	AETERM3	AETERM4	AETERM5	AETERM6	AETERM7	AETERM8	
     AETERM9	EXACN 	EXADJDSC	EXADMREA	EXADMSTA	EXSTR	EXSTRU	ODAE 	ODAECOM 	ODINTENT 	VISITDTC	
     EXDTC	EXSPFY ;

 
Run ;

Data SDTM.EX ;
	Set EX9 ;
	Proc sort ; By STUDYID USUBJID EXTRT EXSTDTC ;
Run ;



 

