

/*******************************************
		Deleting data sets from work library 
*******************************************/

Proc Datasets library = work memtype = data nolist kill ;run ; quit ;

	Dm output "clear"; 
	Dm log "clear";

Data EX ;
	Set ADAM.EX ;
	Where SAFFL = "Y" and EXTRT = "Dummy" ;
Run ;


Data EX102_TEMP ;
	Length var0 var1 var2 var3 var4 var5 var6 var7 var8 var9 var10 $200 ;
	Set EX ;

	Var0 = Strip(GROUP01) ;

	Var1 = Strip(SUBJID) ;

	Var2_ = substr(EXSTDTC,1,10);

	Var2 = Strip(var2_);

	Var3 = Strip(Put(EXSTDY , 6.)) ;

	Var4_ = substr(EXENDTC,1,10);

	if missing(EXENDTC) then var4=put(EXENDTCI,yymmdd10.);
    else Var4 = Strip(Var4_) ;
    
    Var5 = Strip(Put(EXENDY , 6.)) ;

	Var6 = Strip(Put(ADURN , 6.)) ;

	If ^missing(EXSTDY) and ^missing(EXENDY) then ADUR = (EXENDY - EXSTDY)+1;
	else ADUR=(EXENDTCI-(input(EXSTDTC,yymmdd10.)))+1;

	Var7 = Strip(Put(ADUR , 6.)) ;

	Var8 = Strip(Put(EXDOSTOT , 6.)) ;



	Proc sort ; By  Var1 Var2 Var3  ;   

Run ;


/******setting page break*****/

Data EX102;
 	set EX102_TEMP  end = eof;

	 by var1;
   retain _page 1 ORD1 0;
   cnt + 1;
   if cnt > 6 then do;
    _page = _page + 1;
    cnt = .;
   end;
   breaklines = _n_;
   
   if eof then call symputx("totpages",_page); 

   If first.var1 then ord1+1; 		

run;




ods listing close;


options orientation=landscape  topmargin=1.2in bottommargin=1in leftmargin=1in rightmargin=1in nodate nobyline; /*Adjusting the paper*/
ods rtf file= "&root.\Outputs\Listings\EXL1.rtf" /*bodytitle*/;
title1    justify = center   height = 11pt  font = 'Arial' "XYZ";
title2    justify = center   height = 11pt  font = 'Arial' "Appendix 3 Study drug administration - dummy (Safety analysis set)";


proc report data=EX102  nowindows headline headskip split='*'
	style(report)=[background=white rules=NONE frame=void bordertopwidth=2]
	style(header)=[vjust = middle background=white font_face='Arial' font_size=9pt ]
	style(column)=[cellheight=0.3 in];

  By _page ;

	column _page  ORD1 var0 var1 ('Start of drug*administration' var2 var3)  ('End of drug*administration' var4 var5) var6 var7 var8 ;

		define _page / order order=internal noprint;

		define ORD1 / order order=internal noprint;		

		define var0   / order order=internal flow  "Group [a]" style(column)=[cellwidth=0.8in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.8in   just=left  borderbottomcolor=black borderbottomwidth=2];
 
   	    define var1   / order order=internal flow "Subject*identifier" style(column)=[cellwidth=0.8in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.8in   just=left  borderbottomcolor=black borderbottomwidth=2];;

		define var2   /  flow "Date" style(column)=[cellwidth=0.9in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.9in   just=left  borderbottomcolor=black borderbottomwidth=2];

		define var3   /  flow "(day)" style(column)=[cellwidth=0.9in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.9in   just=left  borderbottomcolor=black borderbottomwidth=2];

		define var4   /  flow "Date" style(column)=[cellwidth=0.9in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.9in   just=left  borderbottomcolor=black borderbottomwidth=2];

		define var5   /  flow "(day)" style(column)=[cellwidth=0.7in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.7in   just=left  borderbottomcolor=black borderbottomwidth=2];

		define var6   /  flow "Exposure*(days)" style(column)=[cellwidth=0.8in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.8in   just=left  borderbottomcolor=black borderbottomwidth=2];

		define var7   /  flow "Actual*exposure*(days)" style(column)=[cellwidth=0.8in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.8in   just=left  borderbottomcolor=black borderbottomwidth=2];

		define var8   /  flow "Total*daily*dose*(mg)" style(column)=[cellwidth=0.7in   just=left font_face='Arial' font_size=9pt]
								style(header)=[cellwidth=0.7in   just=left  borderbottomcolor=black borderbottomwidth=2];
		


    /*  break after _page / _page;*/

  compute before _page_ / style={bordertopcolor=black bordertopwidth=1 font_face='Arial' font_size=9pt just=left};

    *** THEAD required to get overline ***;
  endcomp;


  *** This COMPUTE BEFORE block is required to add the skip prior to the first data row ***;

  compute after var1;
    line ' ';
  endcomp;


  compute after _page_ / style={bordertopcolor=black bordertopwidth=1 font_face='Arial' font_size=9pt just=left}; 

  	line j=l "[a] Normal = normal renal function; Severe = severe renal impairment.";
	line j=l "[b] Consecutive interruptions with the same reason are counted as a single interruption, therefore this is excluded from the number/duration of interruptions calculations.";
	line j=l "[c] Dose interrupted but not restarted therefore, this is excluded from the number/duration of interruptions calculations.";
  
   endcomp;
run;