options mprint mlogic;

/*Setting up Path to project*/

/*Change this to where the XYZ folder located in ur PC*/

%let Root = /folders/myfolders/XYZ Study;

/*Creating libraries*/

 libname CDM  "&root./data/data_sas/CDM";
 libname SDTM "&root./data/data_sas/SDTM";
 libname ADAM "&root./data/data_sas/ADAM";

 /*Creating sas data sets*/

 /*CDM datasets*/

%macro CDM (Domain= ) ;

PROC IMPORT DATAFILE= "&root./data/data_excel/CDM/&domain..xlsx"
            DBMS=XLSX OUT= CDM.&domain  ;
     GETNAMES=YES;
RUN;

%mend CDM ;

%CDM (Domain = AE ) ;
%CDM (Domain = DA ) ;
%CDM (Domain = DEATH ) ;
%CDM (Domain = DM ) ;
%CDM (Domain = DS ) ;
%CDM (Domain = EX ) ;
%CDM (Domain = IE ) ;
%CDM (Domain = OVERDOSE ) ;
%CDM (Domain = SERAE ) ;
%CDM (Domain = SPCPKB1 ) ;
%CDM (Domain = VISIT ) ;

/*SDTM datasets*/

%macro SDTM (Domain= ) ;

PROC IMPORT DATAFILE= "&root./data/data_excel/SDTM/&domain..xlsx"
            DBMS=XLSX OUT= SDTM.&domain  ;
     GETNAMES=YES;
RUN;

%mend SDTM ;

%SDTM (Domain = TA ) ;
%SDTM (Domain = TV ) ;

/*ADAM datasets*/

%macro ADAM (Domain= ) ;

PROC IMPORT DATAFILE= "&root./data/data_excel/ADAM/&domain..xlsx"
            DBMS=XLSX OUT= ADAM.&domain  ;
     GETNAMES=YES;
RUN;

%mend ADAM ;

%ADAM (Domain = ADSL ) ;
%ADAM (Domain = ADLB ) ;